program collides;

{$mode Delphi}{$H+}{$R res.res}

uses Windows,PhoeniXLib,SysUtils;
type TBall=record
       spr:PSpriteEx;
       speed:TPhXLVector;
       rot:single;
     end;
var arrBalls:array of TBall;
    cp:TCallProcs;
    texture,bkg:PTexture;
    timer:integer;
    obj_moused:PSpriteEx;
    uo:PUserObject;
    bkgspr:PEasySprite;
    name:array [0..2595] of char;
    path:string;

procedure TimerProc(delta_time:cardinal);stdcall;
var lng:dword;
begin
  lng:=Length(arrBalls);
  SetLength(arrBalls,lng+1);
  arrBalls[lng].spr:=phxlAddSpriteEx(1.5+random*0.1,0);
  arrBalls[lng].spr.texture:=texture;
  if lng=15 then
  phxlDeleteTimer(timer);
end;

procedure WndProc(msg,wparam,lparam:dword);stdcall;
var lng,dw1:integer; x0,y0:single;
begin
  if msg=WM_KEYDOWN then phxlExit;
  if msg=WM_LBUTTONDOWN then
  begin
    lng:=Length(arrBalls)-1;
    if lng=-1 then exit;
    phxlGetWorldCoord(LOWORD(lParam),HIWORD(lParam),x0,y0);
    for dw1:=0 to lng do
      if phxlPointInSprite(PEasySprite(arrBalls[dw1].spr),PHXLPoint(x0,y0)) then
      begin
        obj_moused:=arrBalls[dw1].spr;
        arrBalls[dw1].spr.x:=x0-arrBalls[dw1].spr.w/2;
        arrBalls[dw1].spr.y:=y0-arrBalls[dw1].spr.h/2;
        break;
      end;
  end;
  if (msg=WM_MOUSEMOVE)and((wparam and MK_LBUTTON)=MK_LBUTTON) then
  begin
    if obj_moused=nil then exit;
    phxlGetWorldCoord(LOWORD(lParam),HIWORD(lParam),x0,y0);
    obj_moused.x:=x0-obj_moused.w/2;
    obj_moused.y:=y0-obj_moused.h/2;
  end;
  if (msg=WM_LBUTTONUP) then
  begin
    lng:=Length(arrBalls)-1;
    if (lng=-1)or(obj_moused=nil) then exit;
    phxlGetWorldCoord(LOWORD(lParam),HIWORD(lParam),x0,y0);
    for dw1:=0 to lng do
      if obj_moused=arrBalls[dw1].spr then
      begin
        arrBalls[dw1].speed.x:=(x0-(arrBalls[dw1].spr.x+arrBalls[dw1].spr.w/2))*100;
        arrBalls[dw1].speed.y:=(y0-(arrBalls[dw1].spr.y+arrBalls[dw1].spr.h/2))*100;
        break;
      end;
    obj_moused:=nil;
  end;
  if msg=WM_LBUTTONDBLCLK then
  begin
    phxlGetWorldCoord(LOWORD(lParam),HIWORD(lParam),x0,y0);
    lng:=Length(arrBalls);
    SetLength(arrBalls,lng+1);
    arrBalls[lng].spr:=phxlAddSpriteEx(x0-0.25,y0-0.25);
    arrBalls[lng].spr.texture:=texture;
  end;
  if msg=WM_RBUTTONDOWN then
  begin
    lng:=Length(arrBalls)-1;
    if lng=-1 then exit;
    phxlGetWorldCoord(LOWORD(lParam),HIWORD(lParam),x0,y0);
    for dw1:=0 to lng do
      if phxlPointInSprite(PEasySprite(arrBalls[dw1].spr),PHXLPoint(x0,y0)) then
      begin
        phxlMakeExplode(uo.effects[0],1000,200,35,0.0005,0.00025,0,
          PHXLPoint(arrBalls[dw1].spr.x+arrBalls[dw1].spr.w/2,arrBalls[dw1].spr.y+arrBalls[dw1].spr.h/2));
        phxlMakeShakeEffect(500,30,0.1,0.1,true);
        phxlDeleteSpriteEx(arrBalls[dw1].spr);
        arrBalls[dw1]:=arrBalls[lng];
        SetLength(arrBalls,lng);
        break;
      end;
  end;
end;

procedure RenderProc(ind:byte);stdcall;
var dw1,dw2,dw3:dword; forse,vec1:TPhXLVector;
begin
  dw2:=length(arrBalls);
  if dw2=0 then exit;
  for dw1:=0 to (dw2-1) do
  begin
    if arrBalls[dw1].spr=obj_moused then Continue;
    forse:=PHXLPoint(0,0.0002);
    if arrBalls[dw1].spr.y>(3-arrBalls[dw1].spr.h) then
    forse.y:=forse.y-(arrBalls[dw1].spr.y-(3-arrBalls[dw1].spr.h));
    if arrBalls[dw1].spr.x>(4-arrBalls[dw1].spr.w) then
    forse.x:=forse.x-(arrBalls[dw1].spr.x-(4-arrBalls[dw1].spr.w));
    if arrBalls[dw1].spr.x<0 then
    forse.x:=forse.x-arrBalls[dw1].spr.x;
    for dw3:=0 to (dw2-1) do
    if dw3<>dw1 then
    if phxlCollideSpritesSpheres2(PEasySprite(arrBalls[dw1].spr),PEasySprite(arrBalls[dw3].spr),0.38,vec1) then
    begin
      forse.x:=forse.x-vec1.x/5;
      forse.y:=forse.y-vec1.y/5;
      arrBalls[dw1].rot:=(random-0.5)*10;
    end;
    arrBalls[dw1].spr.angle:=arrBalls[dw1].spr.angle+arrBalls[dw1].rot;
    arrBalls[dw1].rot:=arrBalls[dw1].rot*0.99;
    arrBalls[dw1].speed.x:=arrBalls[dw1].speed.x+forse.x;
    arrBalls[dw1].speed.y:=arrBalls[dw1].speed.y+forse.y;
    arrBalls[dw1].spr.x:=arrBalls[dw1].spr.x+arrBalls[dw1].speed.x;
    arrBalls[dw1].spr.y:=arrBalls[dw1].spr.y+arrBalls[dw1].speed.y;
    arrBalls[dw1].speed.x:=arrBalls[dw1].speed.x*0.99;
    arrBalls[dw1].speed.y:=arrBalls[dw1].speed.y*0.99;
  end;
end;
  
begin
cp[0]:=@WndProc;
cp[1]:=@RenderProc;
GetModuleFileName(0,name,MAX_PATH);
path:=ExtractFilePath(name);
phxlInit(PHXL_VSYNC or PHXL_FULL_SCREEN or PHXL_ON_TOP,@cp,0,0,800,600,'CollidesExp',1000);
texture:=phxlAddTexture(PChar(path+'ball.tga'),tfMMLinear,tmReplace,tcqNone,true,true,true);
bkg:=phxlAddTexture(PChar(path+'bkg.tga'),tfNearest,tmDecal,tcqRGBA_DXT3,false,true,false);
if bkg<>nil then
begin
  bkgspr:=phxlAddEasySprite(1.21875,0.5);
  bkgspr.texture:=bkg;
  bkgspr.w:=1.56;
  bkgspr.h:=0.9765625;
end;
uo:=phxlAddUserObject(1,nil);
uo.effects_enable:=true;
uo.effects[0]:=phxlAddParticles(nil,nil,0.1,100000,40,0,nil);
uo.effects[0].particle_attenuation:=true;
uo.effects[0].color1:=PHXLColor(1,1,1,0.8);
uo.effects[0].color2:=PHXLColor(1,1,1,0);
timer:=phxlAddTimer(true,@TimerProc,2000);
phxlStart;
arrBalls:=nil;
end.

